pipeline {
    agent any

    post {
        failure {
            updateGitlabCommitStatus name: 'install npm dependencies', state: 'failed'
            updateGitlabCommitStatus name: 'unit test', state: 'failed'
        }
        success {
            updateGitlabCommitStatus name: 'install npm dependencies', state: 'success'
            updateGitlabCommitStatus name: 'unit test', state: 'success'
        }
    }

    options {
        gitLabConnection ('gitlab_connection')
    }

    triggers {
        gitlab(triggerOnPush: true, triggerOnMergeRequest: true, branchFilterType: 'All')
    }

    stages {
        stage("install npm dependencies") {
            steps {
                script {
                    sh "npm install"
                }
            }
        }

        stage("unit test") {
            steps {
                script {
                    sh "npm run test"
                }
            }
        }
    }
}